llog = require("llog")

script.on_event(defines.events.on_player_created, function(event)
    local player = game.players[event.player_index]

    player.gui.left.add{type="button", name="test_action", caption="Action"}
end)

local function material_as_ingredient(recipe)
    for _, ingredient in pairs(recipe.ingredients) do
        if ingredient.name == "limestone" then return true end
    end
    return false
end

local function sorting_function(a, b)
    if a.group.order < b.group.order then return true
    elseif a.group.order > b.group.order then return false
    elseif a.subgroup.order < b.subgroup.order then return true
    elseif a.subgroup.order > b.subgroup.order then return false
    elseif a.order < b.order then return true
    elseif a.order > b.order then return false end
    return false
end

local function comp(a, b)
    if a.name == b.name then return false
    elseif a.name == "limestone" or b.name == "limestone" then return (a.name == "limestone")
    elseif material_as_ingredient(a) ~= material_as_ingredient(b) then return material_as_ingredient(b)
    elseif a.allow_as_intermediate ~= b.allow_as_intermediate then return a.allow_as_intermediate
    else return sorting_function(a, b) end
end

local function print(recipes)
    log("Recipe order:")
    for index, recipe in pairs(recipes) do
        log(index .. ": " .. recipe.name)
    end
end

script.on_event(defines.events.on_gui_click, function(event)
    local player = game.players[event.player_index]
    if event.element.name == "test_action" then
        local recipes = {}
        for _, recipe in pairs(prototypes.recipe) do
            if not recipe.hidden and recipe.allow_decomposition then
                for _, product in pairs(recipe.products) do
                    if product.name == "limestone" then
                        table.insert(recipes, recipe)
                    end
                end
            end
        end
        print(recipes)
        table.sort(recipes, comp)
        print(recipes)
    end
end)
